
#define  INCL_WIN
#define  INCL_DOS
#define  INCL_GPI
#include <memory.h>
#include <os2.h>
#include <stdio.h>
#include "joyos2.h"
#define  CLASSNAME            "joy1"
#define  UM_QUERYJOYSTICK     (0x0001)
#define  UM_QUERYPOSITION     (0x0002)
#define  MARKSIZE             (6)
#define  MOVEPITCH            (1)

void              main( void );
MRESULT EXPENTRY  ClientWndProc( HWND, ULONG, MPARAM, MPARAM );

void main( void )
{
   HAB      hab;
   HMQ      hmq;
   QMSG     qmsg;
   HWND     hwndFrame,
            hwndClient;
   ULONG    ulFlags;

   hab = WinInitialize( 0 );
   hmq = WinCreateMsgQueue( hab, 0 );

   WinRegisterClass( hab, CLASSNAME, ClientWndProc, CS_SIZEREDRAW, 0 );

   ulFlags = FCF_SIZEBORDER | FCF_TITLEBAR | FCF_SYSMENU | FCF_MINMAX | FCF_TASKLIST;
   hwndFrame = WinCreateStdWindow( HWND_DESKTOP, WS_VISIBLE, & ulFlags, CLASSNAME, "Joystick",
                     0, NULLHANDLE, 0, & hwndClient );
   WinSetWindowPos( hwndFrame, HWND_TOP, 100, 100, 500, 500, SWP_ZORDER | SWP_ACTIVATE | SWP_SIZE );

   while( WinGetMsg( hab, & qmsg, 0, 0, 0 ) )
      WinDispatchMsg( hab, & qmsg );

   WinDestroyWindow( hwndFrame );
   WinDestroyMsgQueue( hmq );
   WinTerminate( hab );
   return;
}

MRESULT EXPENTRY ClientWndProc( HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2 )
{
   HPS                        hps;
   RECTL                      rcl;
   SWP                        swp;
   static HFILE               hJoystick;
   static POINTL              aptPos[ 4 ], aptPos2[ 4 ], ptCharPos;
   ULONG                      ulAct;
   ULONG                      ulLen;
   static ULONG               ulWidth, ulHeight;
   CHAR                       cPad;
   static CHAR                fPaint = 0;
   static GAME_PARM_STRUCT    gparms;
   static GAME_CALIB_STRUCT   gcalib;
   static GAME_STATUS_STRUCT  gstatus;
   static GAME_3POS_STRUCT  * gCaX, * gCaY;
   static GAME_2DPOS_STRUCT * gPos;
   static LINEBUNDLE          lbnd, lbnd2;
   static CHARBUNDLE          cbnd;
   static CHAR                szButton[ 5 ], szButton2[ 5 ];
   APIRET                     ret;

   switch( msg ) {

   case WM_CREATE :
      ret = DosOpen( "game$", & hJoystick, & ulAct, 0, FILE_READONLY, OPEN_ACTION_OPEN_IF_EXISTS,
                        OPEN_ACCESS_READONLY | OPEN_SHARE_DENYNONE, NULL );
      printf( "Open game$        : %d, handle ID %d\n", ret, hJoystick );
      lbnd  . lColor     = CLR_WHITE;
      lbnd2 . fxWidth    = 2;
      lbnd2 . lColor     = CLR_DARKBLUE;
      cbnd  . lColor     = CLR_WHITE;
      cbnd  . lBackColor = CLR_DARKBLUE;
      szButton[ 4 ]      = '\0';
//    szButton2[ 0 ]     = ' ';
//    szButton2[ 1 ]     = ' ';
//    szButton2[ 2 ]     = ' ';
//    szButton2[ 3 ]     = ' ';
//    szButton2[ 4 ]     = '\0';
      WinPostMsg( hwnd, WM_USER, MPFROMSHORT( UM_QUERYJOYSTICK ), MPVOID );
      break;

   case WM_SIZE :
      WinQueryWindowPos( hwnd, & swp );
      if( ! ulWidth | ! ulHeight ) {
         ulWidth  = swp . cx;
         ulHeight = swp . cy;
         aptPos[ 0 ] . x = ( ulWidth  - MARKSIZE ) >> 1;
         aptPos[ 0 ] . y = ( ulHeight - MARKSIZE ) >> 1;
      } else {
         aptPos[ 0 ] . x = aptPos[ 0 ] . x * swp . cx / ulWidth;
         aptPos[ 0 ] . y = aptPos[ 0 ] . y * swp . cx / ulHeight;
      }
      aptPos[ 1 ] . x = aptPos[ 0 ] . x + MARKSIZE;
      aptPos[ 1 ] . y = aptPos[ 0 ] . y;
      aptPos[ 2 ] . x = aptPos[ 0 ] . x + MARKSIZE;
      aptPos[ 2 ] . y = aptPos[ 0 ] . y + MARKSIZE;
      aptPos[ 3 ] . x = aptPos[ 0 ] . x;
      aptPos[ 3 ] . y = aptPos[ 0 ] . y + MARKSIZE;
      ptCharPos . x   = swp.cx >> 1 - 10;
      ptCharPos . y   = 5;
      memcpy( aptPos2, aptPos, sizeof( POINTL ) << 2 );
      ulWidth  = swp . cx;
      ulHeight = swp . cy;
      fPaint = 0;
      break;

   case WM_PAINT :
      hps = WinBeginPaint( hwnd, NULLHANDLE, & rcl );
      switch( fPaint ) {
      case 0 :
         WinFillRect( hps, & rcl, CLR_DARKBLUE );
         WinDrawText( hps, -1, "Push [space] to start!!", & rcl, CLR_WHITE, 0, DT_CENTER | DT_VCENTER );
         fPaint = 1;
         printf( "paint 0\n" );
         break;

      case 1 :
         WinFillRect( hps, & rcl, CLR_DARKBLUE );
         printf( "paint 1\n" );
         WinPostMsg( hwnd, WM_USER, MPFROMSHORT( UM_QUERYPOSITION ), MPVOID );
         fPaint = 2;
         break;

      case 2 :
         GpiMove( hps, & aptPos2[ 3 ] );
         GpiSetAttrs( hps, PRIM_LINE, LBB_COLOR | LBB_WIDTH, 0, & lbnd2 );
         GpiPolyLine( hps, 4, aptPos2 );
//       WinDrawText( hps, -1, szButton2, & rcl, CLR_DARKBLUE, 0, DT_CENTER | DT_VCENTER );
         GpiMove( hps, & aptPos[ 3 ] );
         GpiSetAttrs( hps, PRIM_LINE, LBB_COLOR, 0, & lbnd );
         GpiPolyLine( hps, 4, aptPos );
         WinDrawText( hps, -1, szButton,  & rcl, CLR_WHITE, 0, DT_CENTER | DT_VCENTER );
         WinPostMsg( hwnd, WM_USER, MPFROMSHORT( UM_QUERYPOSITION ), MPVOID );
         break;
      }
      WinEndPaint( hps );
      break;

   case WM_CHAR :
      switch( SHORT1FROMMP( mp2 ) ) {
      case ' ' :
         WinInvalidateRect( hwnd, NULL, FALSE );
         break;
      }
      break;

   case WM_CLOSE :
      ret = DosClose( hJoystick );
      printf( "Close game$       : %d\n", ret );
      WinPostMsg( hwnd, WM_QUIT, MPVOID, MPVOID );
      break;

   case WM_USER :
      switch( SHORT1FROMMP( mp1 ) ) {
      case UM_QUERYJOYSTICK :
         ret = DosDevIOCtl( hJoystick, IOCTL_CAT_USER, GAME_GET_PARMS, NULL, 0, NULL, & gparms,
                           sizeof( GAME_PARM_STRUCT ), & ulLen );
         printf( "GetParms game$    : %d\n", ret );
         if( gparms . useA != 0 ) {
            WinSetWindowText( WinQueryWindow( hwnd, QW_PARENT ), "Joystick - A" );
            gCaX = & gcalib . Ax;
            gCaY = & gcalib . Ay;
            gPos = & gstatus . curdata . A;
            cPad = 'A';
         } else if( gparms . useB != 0 ) {
            WinSetWindowText( WinQueryWindow( hwnd, QW_PARENT ), "Joystick - B" );
            gCaX = & gcalib . Bx;
            gCaY = & gcalib . By;
            gPos = & gstatus . curdata . B;
            cPad = 'B';
         }
         ret = DosDevIOCtl( hJoystick, IOCTL_CAT_USER, GAME_GET_CALIB, NULL, 0, NULL, & gcalib,
                           sizeof( GAME_CALIB_STRUCT ), & ulLen );
         printf( "GetCAlib game$    : %d, Pad %c\n", ret, cPad );
         printf( "calib x           : %d, %d, %d\n", gCaX -> lower, gCaX -> centre, gCaX -> upper );
         printf( "calib y           : %d, %d, %d\n", gCaY -> lower, gCaY -> centre, gCaY -> upper );
         break;

      case UM_QUERYPOSITION :
         memcpy( aptPos2, aptPos, sizeof( POINTL ) << 2 );
         ret = DosDevIOCtl( hJoystick, IOCTL_CAT_USER, GAME_GET_STATUS, NULL, 0, NULL, & gstatus,
                           sizeof( GAME_STATUS_STRUCT ), & ulLen );
         if( gPos -> x < gCaX -> lower  ) aptPos[ 0 ] . x -= MOVEPITCH;
         if( gPos -> x > gCaX -> upper  ) aptPos[ 0 ] . x += MOVEPITCH;
//       if( gPos -> x < gCaX -> centre ) aptPos[ 0 ] . x -= MOVEPITCH;
//       if( gPos -> x > gCaX -> centre ) aptPos[ 0 ] . x += MOVEPITCH;
         if( gPos -> y < gCaY -> lower  ) aptPos[ 0 ] . y += MOVEPITCH;
         if( gPos -> y > gCaY -> upper  ) aptPos[ 0 ] . y -= MOVEPITCH;
//       if( gPos -> y < gCaY -> centre ) aptPos[ 0 ] . y += MOVEPITCH;
//       if( gPos -> y > gCaY -> centre ) aptPos[ 0 ] . y -= MOVEPITCH;
         if( aptPos[ 0 ] . x < 0                   ) aptPos[ 0 ] . x = 0;
         if( aptPos[ 0 ] . x > ulWidth  - MARKSIZE ) aptPos[ 0 ] . x = ulWidth - MARKSIZE;
         if( aptPos[ 0 ] . y < 0                   ) aptPos[ 0 ] . y = 0;
         if( aptPos[ 0 ] . y > ulHeight - MARKSIZE ) aptPos[ 0 ] . y = ulHeight - MARKSIZE;
         aptPos[ 1 ] . x = aptPos[ 0 ] . x + MARKSIZE;
         aptPos[ 1 ] . y = aptPos[ 0 ] . y;
         aptPos[ 2 ] . x = aptPos[ 0 ] . x + MARKSIZE;
         aptPos[ 2 ] . y = aptPos[ 0 ] . y + MARKSIZE;
         aptPos[ 3 ] . x = aptPos[ 0 ] . x;
         aptPos[ 3 ] . y = aptPos[ 0 ] . y + MARKSIZE;
//       memcpy( szButton2, szButton, 5 );
         if( gstatus . b1cnt != 0 ) szButton[ 0 ] = 'A'; else szButton[ 0 ] = ' ';
         if( gstatus . b2cnt != 0 ) szButton[ 1 ] = 'B'; else szButton[ 1 ] = ' ';
         if( gstatus . b3cnt != 0 ) szButton[ 2 ] = 'C'; else szButton[ 2 ] = ' ';
         if( gstatus . b4cnt != 0 ) szButton[ 3 ] = 'D'; else szButton[ 3 ] = ' ';

         WinInvalidateRect( hwnd, NULL, FALSE );
         break;
      }
      break;

   default :
      return( WinDefWindowProc( hwnd, msg, mp1, mp2 ) );
      break;
   }
   return( 0 );
}

